#include "BannerScreen.h"

BannerScreen::BannerScreen() {
}

BannerScreen::~BannerScreen() {
}

void BannerScreen::Init() {
	texBanners[0] = SOIL_load_OGL_texture ( "intro1.png",
										SOIL_LOAD_AUTO,
										SOIL_CREATE_NEW_ID,
										SOIL_FLAG_MIPMAPS | SOIL_FLAG_NTSC_SAFE_RGB | SOIL_FLAG_COMPRESS_TO_DXT
	  );
	int width = 0, height = 0, channels = 0;
	GLubyte * imgArray;
	//imgArray = SOIL_load_image (
	//	"intro1.png",
	//	&width, &height, &channels,
	//	SOIL_LOAD_AUTO
	//	);

	//glGenTextures(1, &texBanners[0]);
	//glBindTexture(GL_TEXTURE_2D, texBanners[0]);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	//if(channels == 4)
	//{
	//	for(unsigned int i = 3; i < width * height * 4; i=i+4) {
	//		if(imgArray[i] != 0)
	//			imgArray[i] = 191;
	//	}
	//	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, imgArray);
	//}
	//else
	//	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, imgArray);

	//SOIL_free_image_data( imgArray );

	/////////////////////////////////////////////////////////////////////////////////
	imgArray = SOIL_load_image (
		"help.png",
		&width, &height, &channels,
		SOIL_LOAD_AUTO
		);

	glGenTextures(1, &texBanners[1]);
	glBindTexture(GL_TEXTURE_2D, texBanners[1]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	if(channels == 4)
	{
		for(unsigned int i = 3; i < width * height * 4; i=i+4) {
			if(imgArray[i] != 0)
				imgArray[i] = 191;
		}
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, imgArray);
	}
	else
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, imgArray);

	SOIL_free_image_data( imgArray );

	/////////////////////////////////////////////////////////////////////////////////
	imgArray = SOIL_load_image (
		"outro1.png",
		&width, &height, &channels,
		SOIL_LOAD_AUTO
		);

	glGenTextures(1, &texBanners[2]);
	glBindTexture(GL_TEXTURE_2D, texBanners[2]);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	if(channels == 4)
	{
		for(unsigned int i = 3; i < width * height * 4; i=i+4) {
			if(imgArray[i] != 0)
				imgArray[i] = 191;
		}
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, imgArray);
	}
	else
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_RGB, GL_UNSIGNED_BYTE, imgArray);

	SOIL_free_image_data( imgArray );


	// build display list
	float z = 0.0;
	float y = 0.9;
	float x = 0.9;

	listName = glGenLists (1);
	glNewList (listName, GL_COMPILE);
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, texBanners[currentBanner]);
		glMatrixMode (GL_MODELVIEW); 
		glPushMatrix (); 
		glLoadIdentity (); 
		glMatrixMode (GL_PROJECTION); 
		glPushMatrix (); 
		glLoadIdentity ();
		glEnable (GL_BLEND); 
		glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

		glDepthMask(GL_FALSE);
		glDisable(GL_DEPTH_TEST);

		glColor4f(1,1,1,0.85);
		glBegin (GL_QUADS);
		// Top left
		glTexCoord2i(0, 0);
		glVertex3f(-x, y, z);

		// Bottom left
		glTexCoord2i(1, 0);
		glVertex3f(x, y, z); 

		// Bottom right
		glTexCoord2i(1, 1);
		glVertex3f(x, -y, z); 

		// Top right
		glTexCoord2i(0, 1);
		glVertex3f(-x, -y, z); 
		glEnd ();
		glColor4f(1,1,1,1);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
		glDisable (GL_BLEND); 

		glPopMatrix (); 
		glMatrixMode (GL_MODELVIEW); 
		glPopMatrix ();
	glEndList ();

}

// based on code from Abdul
//http://www.opengl.org/resources/faq/technical/transformations.htm#tran0090
void BannerScreen::Render() {
	if(!visible)
		return;

	glCallList (listName);

	if(!shown) {
		shown = true;
		timStartDisplay = GetTickCount();
	} else {
		if(currentBanner !=1 && GetTickCount() - timStartDisplay > 5000)
			visible = false;
	}
}