#ifndef _BANNERSCREEN_H_
#define _BANNERSCREEN_H_

#include <windows.h>
#include <GL/glut.h>
#include <GL/Soil.h>

class BannerScreen {
private:
  bool visible;
  bool shown;
  DWORD timStartDisplay;
  GLuint texBanners[3];
  int currentBanner;
  GLuint listName;

public:
  BannerScreen();
  ~BannerScreen();

  void Init();
  void Render();
  bool IsVisible() const { return visible; };
  void Enable(int iBanner) {
    visible = true;
    currentBanner = iBanner;
  };
  void Disable() { visible = false ; };
};


#endif