#ifndef _TERRAIN_H_
#define _TERRAIN_H_

#include "GLee.h"
#include <vector>
#include "vector_inl.h"
//#include <GL/gl.h>
#include <GL/glut.h>
#include <math.h>
#include "soil.h"


struct MyVertex {
  float x, y, z;       //Vertex
  float nx, ny, nz;    //Normal
  float s0, t0;        //Texcoord0
};

class Terrain {
  GLuint texGround;
public:
	Terrain(void);
	~Terrain();
	Terrain(unsigned int rows, unsigned int cols);

	std::vector<MyVertex> m_vertices1;
	unsigned int m_rows;
	unsigned int m_cols;
	std::vector<std::vector<unsigned int>> m_strips;

	void InitTexture();
  void Render();
	void InitTerrain(unsigned int width, unsigned int height);
	float GetHeight(float x, float z);
};

#endif