#ifndef _SKYMAP_H_
#define _SKYMAP_H_

#include "GLee.h"
#include <stdlib.h>
#include <GL/glut.h>
#include <GL/Soil.h>
#include <stdio.h>
#include <iostream>
#include <string>
#include <sstream>
#include <vector>
#include "vector_inl.h"


template <class T>
std::string val_to_string(T& t)
{
  std::ostringstream o;
	o << t;
   //if (!(o << t))
   //  throw BadConversion(std::string("stringify(")
   //                      + typeid(t).name() + ")");
   return o.str();
}

class SkyMap {
public:
  std::vector <GLuint> texSky;

  SkyMap() { }
  ~SkyMap() { }

  void Init();
  //void Render(const GLdouble & centerx, const GLdouble & centery, const GLdouble & centerz );
  void Render(const Vector3d & center, std::string timeOfDay );
};
#endif